Ext.define('App.store.Messages', {
	extend: 'Ext.data.Store',
	
	config: {
		model: 'App.model.Message'
	},
	
	//filter store by user id
	filterByUser: function (user_id) {
		this.clearFilter();
		
		this.filterBy(function(record) {
			//is message is with specified user
			if (user_id == record.get('message_with')) {
				//return true
				return true;
			} else {
				//else return false
				return false;
			}
		});
	},
	
	//mark messages from user as read
	readMessages: function(user_id) {
		var readIds = [];
		
		//parse all messages
		this.each(function(record) {
			//if message is with specified user, was not sent and was not read
			if (user_id == record.get('message_with') && false == record.get('sent') && 0 == record.get('message_read')) {
				//set it as read
				record.set('message_read', 1);
				//add it to "to be read" messages array
				readIds.push(record.get('message_id'));
			}
		});
		
		//if there is any message to be read
		if (0 < readIds.length) {
			//send the array to server
			socket.emit('messages_read', JSON.stringify(readIds));
		}
	},
});
