Ext.define('App.store.OnlineUsers', {
	extend: 'Ext.data.Store',
	
	config: {
		model: 'App.model.OnlineUser'
	},
	
	//add unread message from user
	addUnreadMessage: function(user_id) {
		//parse online users
		this.each(function(record) {
			if (user_id == record.get('user_id')) {
				//set new message flag
				record.set('new_messages', true);
				//change number of new messages
				record.set('no_new_messages', record.get('no_new_messages')+1);
			}
		});		
	},
	
	//mark messages as read
	readMessages: function(user_id) {
		//parse all users
		this.each(function(record) {
			//if user matches the user id
			if (user_id == record.get('user_id')) {
				//set to false new message flag
				record.set('new_messages', false);
				//set no of new messages to 0
				record.set('no_new_messages', 0);
			}
		});
	},
	
	//remove online user from list
	removeUser: function(user_id) {
		var searchRecord = null;
		
		//search the user record
		this.each(function(record) {
			if (user_id == record.get('user_id')) {
				searchRecord = record;
			}
		});
		
		if (!searchRecord) {
			return;
		}
		
		//remove it from store
		this.remove(searchRecord);
	}
});
