Ext.define('App.view.chat.Chat', {
	extend: 'Ext.Panel',
	
	xtype: 'chatView',
	
	config: {
		layout: 'fit',
		cls: 'chatView',
		items: [
		    //top toolbar
			{
				xtype: 'toolbar',
				docked: 'top',
				itemId: 'topChatBar',
				cls: 'topBar',
				title: '',
				items: [
				    //back button
					{
						xtype: 'button',
						itemId: 'backButton',
						ui: 'back',
						text: 'Back'
					}
				]
			},
			//bottom toolbar
			{
				xtype: 'toolbar',
				docked: 'bottom',
				cls: 'bottomBar',
				items: [
				    //message content input
					{
						xtype: 'textareafield',
						name: 'messageInput',
						itemId: 'messageInput',
						flex: 6,
						maxRows: 4
					},
					//send message
					{
						xtype: 'button',
						itemId: 'messageButton',
						ui: 'action',
						text: 'Send',
						flex: 1
					}
				]
			},
			//messages list
			{
				xtype: 'list',
				disableSelection: true,
				store: 'Messages',
				itemId: 'messageList',
				layout: 'fit',
				cls: 'messageList',
				itemTpl: new Ext.XTemplate(
					'<tpl if="sent">',
						'<div class="x-button x-button-confirm sent message-container" style="float: right;">',
							'<p class="x-button-label message">{message_content}</p>',
						'</div>',
					'<tpl else>',
						'<div class="x-button received message-container" style="float: left;">',
							'<p class="x-button-label message">{message_content}</p>',
						'</div>',
					'</tpl>'
				)
			},
		]
	}
});
