var crypto = require('crypto');
var config = require('./../config');

//generate random string by the specified length
var randomString = function(length) {
	//the chars set to be used
	var charset = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	
	var result = "";
	
	//choose a random char for "length" number of times
	for (var i = 0; i < length; i++) {
		result += charset.charAt(Math.floor(Math.random() * charset.length));
	}
	
	return result;
};

//crypt the password with the specified salt or a new one
var cryptPassword = function(password, salt) {
	var randString = salt || randomString(config.saltLength);
	
	return randString + crypto.createHash('md5').update(password + randString).digest('hex');
};

//check if the hash of the given password matches the given hash
var checkPassword = function(password, passwordHash) {
	var salt = passwordHash.substring(0, config.saltLength);
	
	return (passwordHash == cryptPassword(password, salt));
};

exports.randomString = randomString;
exports.cryptPassword = cryptPassword;
exports.checkPassword = checkPassword;
