var sql = require('./db');
var crypt = require('./crypt');

//get user that matches the username
var get_user_by_username = function(user_username) {
	//query to select the user that matches the username
	var query = 'SELECT * FROM '+sql.tablePrefix+'users WHERE user_username = ? LIMIT 1';
	
	var result = null;
	//execute the query
	sql.connection.query().execute(query, [user_username], function(error, rows, cols) {
		if (error) {
			console.log(query);
			console.log(error);
			return;
		}
		
		result = rows;
	}, {'async': false});
	
	//return the result
	return result;
};

//get user that matches the id
var get_user_by_id = function(user_id) {
	//query to select the user that matches the id
	var query = 'SELECT * FROM '+sql.tablePrefix+'users WHERE user_id = ? LIMIT 1';
	
	var result = null;
	sql.connection.query().execute(query, [user_id], function (error, rows, cols) {
		if (error) {
			console.log(query);
			console.log(error);
			return;
		}
		
		result = rows;
	}, {'async': false});
	
	return result;
};

//save new user to database
var save_user = function (user_username, user_password) {
	user_password = crypt.cryptPassword(user_password);
	
	//query to insert new user to db
	var query = 'INSERT INTO ' +
				 sql.tablePrefix+'users ' +
				'SET ' +
				'user_username = ?, ' +
				'user_password = ? ';
				
	sql.connection.query().execute(
		query,
		[user_username, user_password],
		function (error, rows, cols, result) {
			if (error) {
				console.log(error);
				return;
			}
		}
	);
};

//check if username is valid
var check_username = function(user_username) {
	if (100 <= user_username.length) {
		return false;
	}
	
	return true;
};

exports.save_user = save_user;
exports.get_user_by_username = get_user_by_username;
exports.get_user_by_id = get_user_by_id;
exports.check_username = check_username;
exports.crypt = crypt;
